// ActiveSyncFix.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ActiveSyncFix.h"
#include <WinGDI.h>


#define MAX_LOADSTRING 100

#define T20

#define HHTASKBARCLASSNAME     TEXT("HHTaskBar")
#define HHTASKBARDATA          8

static HINSTANCE g_hInstance;

LRESULT CALLBACK TaskBarWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

HWND CreateTaskbar()
{
	WNDCLASS wc;
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)TaskBarWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = HHTASKBARDATA;
	wc.hInstance = g_hInstance;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = NULL;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = HHTASKBARCLASSNAME;

	if(!RegisterClass(&wc))
	{
		ERRORMSG(1, (L"RegisterClass() failed, GetLastError = 0x%x\r\n", GetLastError()));
		return NULL;
	}

	RECT rc;
	SetRect(&rc, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));

	HWND m_hwndTaskBar = CreateWindowEx(
		0,
		HHTASKBARCLASSNAME,
		L"",
		WS_POPUP,
		rc.left,
		rc.top,
		rc.right - rc.left,
		rc.bottom - rc.top,
		NULL,
		NULL,
		g_hInstance,
		NULL
		);

	if(!m_hwndTaskBar)
	{
		ERRORMSG(1, (L"CreateWindowEx() failed, GetLastError = 0x%x\r\n", GetLastError()));
	}

	return m_hwndTaskBar;
}

#define NUM_APIS    74

void ShellApiReservedForNK (void);
extern "C" void ShellNotifyCallback(DWORD cause, DWORD proc, DWORD thread);

BOOL WINAPI SHCreateExplorerInstance(LPCTSTR pszPath, UINT uFlags)
{
	return FALSE;
}

BOOL WINAPI Shell_NotifyIconI(DWORD dwMsg, PNOTIFYICONDATA pNID, DWORD cbNID)
{
	return FALSE;
}

void ShellApiReservedForNK(void)
{
}

extern "C" void ShellNotifyCallback(DWORD cause, DWORD proc, DWORD thread)
{
	return;
}

BOOL PlaceHolder(DWORD dw)
{
	return FALSE;
}

const PFNVOID VTable[NUM_APIS] = {
	//xref ApiSetStart
	(PFNVOID) ShellNotifyCallback,
	(PFNVOID) ShellApiReservedForNK, /* Reserved for NK */
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder/*XGetOpenFileName*/,
	(PFNVOID) PlaceHolder/*XGetSaveFileName*/,
	(PFNVOID) PlaceHolder/*XSHGetFileInfo*/,
	(PFNVOID) Shell_NotifyIconI,
	(PFNVOID) PlaceHolder, /* SHAddToRecentDocs */
	(PFNVOID) PlaceHolder/*SHCreateShortcut*/,
	(PFNVOID) SHCreateExplorerInstance,
	(PFNVOID) PlaceHolder, //internalSHRemoveFontResource,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder/*SHGetShortcutTarget*/,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder/*xxx_SHLoadDIBitmap*/,
	(PFNVOID) PlaceHolder/*SHSetDesktopPosition*/,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder, //24
	(PFNVOID) PlaceHolder, //25
	(PFNVOID) PlaceHolder, //26
	(PFNVOID) PlaceHolder, 
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder, // 30
	(PFNVOID) PlaceHolder, //31
	(PFNVOID) PlaceHolder, //32
	(PFNVOID) PlaceHolder, //33
	(PFNVOID) PlaceHolder, //34
	(PFNVOID) PlaceHolder, //35
	(PFNVOID) PlaceHolder, //36
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder, //39
	(PFNVOID) PlaceHolder, //40
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder, //43
	(PFNVOID) PlaceHolder, //44
	(PFNVOID) PlaceHolder, //45
	(PFNVOID) PlaceHolder, //46
	(PFNVOID) PlaceHolder, //47
	(PFNVOID) PlaceHolder, //48
	(PFNVOID) PlaceHolder, //49
	(PFNVOID) PlaceHolder, //50
	(PFNVOID) PlaceHolder, //51
	(PFNVOID) PlaceHolder, //52
	(PFNVOID) PlaceHolder, //53
	(PFNVOID) PlaceHolder, //54
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder,
	(PFNVOID) PlaceHolder, //58
	(PFNVOID) PlaceHolder, //59
	(PFNVOID) PlaceHolder, //60
	(PFNVOID) PlaceHolder, //61
	(PFNVOID) PlaceHolder, //62
	(PFNVOID) PlaceHolder, //63
	(PFNVOID) PlaceHolder, //64
	(PFNVOID) PlaceHolder, //65
	(PFNVOID) PlaceHolder, //66
	(PFNVOID) PlaceHolder, //67
	(PFNVOID) PlaceHolder, //68
	(PFNVOID) PlaceHolder, //69
	(PFNVOID) PlaceHolder, //70
	(PFNVOID) PlaceHolder, //71
	(PFNVOID) PlaceHolder, //72
	(PFNVOID) PlaceHolder, // 73 - new and internal for mckendrick
	//xref ApiSetEnd
};

const ULONGLONG SigTable[NUM_APIS] = {
	FNSIG3(DW,DW,DW), // ShellNotifyCallback
	FNSIG0(),  //ShellApiReservedForNK
	FNSIG1(DW), // PlaceHolder (was: ShellExecuteEx)
	FNSIG1(DW)/*FNSIG1(PTR)*/, //GetOpenFileName
	FNSIG1(DW)/*FNSIG1(PTR)*/, //GetSaveFileName
	FNSIG1(DW), // xxx_SHGetFileInfo
	FNSIG3(DW,I_PTR, DW), // Shell_NotifyIcon
	FNSIG1(DW), // SHAddToRecentDocs
	FNSIG1(DW)/*FNSIG2(PTR,PTR)*/, // SHCreateShortcut
	FNSIG2(I_WSTR,DW), // SHCreateExplorerInstance
	FNSIG1(DW), // SHRemoveFontResource
	FNSIG1(DW), // 
	FNSIG1(DW), // 
	FNSIG1(DW), // 
	FNSIG1(DW), // 
	FNSIG1(DW), // 
	FNSIG1(DW), // PlaceHolder
	FNSIG1(DW), // PlaceHolder
	FNSIG1(DW)/*FNSIG3(PTR, PTR, DW)*/, // SHGetShortcutTarget
	FNSIG1(DW), // PlaceHolder
	FNSIG1(DW), // PlaceHolder
	FNSIG1(DW)/*FNSIG1(PTR)*/, // SHLoadDIBitmap
	FNSIG1(DW)/*FNSIG3(DW, DW, DW)*/, // SHSetDesktopPosition
	FNSIG1(DW), // SHFileChange
	FNSIG1(DW), // PlaceHolder
	FNSIG1(DW), // PlaceHolder
	FNSIG1(DW), // PlaceHolder
	FNSIG1(DW), //NotSystemParametersInfo
	FNSIG1(DW), // SHGetAppKeyAssoc
	FNSIG1(DW), // SHSetAppKeyWndAssoc
	FNSIG1(DW), // PlaceHolder  30
	FNSIG1(DW), // PlaceHolder  31
	FNSIG1(DW), // PlaceHolder  32
	FNSIG1(DW), // PlaceHolder  33
	FNSIG1(DW), // SHFileNotifyRemove
	FNSIG1(DW), // SHFileNotifyFree
	FNSIG1(DW), // PlaceHolder  36
	FNSIG1(DW), // SHCloseApps
	FNSIG1(DW), // SHSipPreference
	FNSIG1(DW), // PlaceHolder  39
	FNSIG1(DW), // PlaceHolder  40
	FNSIG1(DW), // SHSetNavBarText
	FNSIG1(DW), // SHDoneButton
	FNSIG1(DW), // PlaceHolder  43
	FNSIG1(DW), // PlaceHolder  44
	FNSIG1(DW), // PlaceHolder  45
	FNSIG1(DW), // PlaceHolder  46
	FNSIG1(DW), // PlaceHolder  47
	FNSIG1(DW), // PlaceHolder  48
	FNSIG1(DW), // PlaceHolder  49
	FNSIG1(DW), //SHChangeNotifyRegister
	FNSIG1(DW), // PlaceHolder  51
	FNSIG1(DW), // PlaceHolder  52
	FNSIG1(DW), // PlaceHolder  53
	FNSIG1(DW), // PlaceHolder  54
	FNSIG1(DW), // SHNotificationAdd
	FNSIG1(DW), //SHNotificationUpdate
	FNSIG1(DW), //SHNotificationRemove
	FNSIG1(DW), //SHNotificationGetData
	FNSIG1(DW), // PlaceHolder  59
	FNSIG1(DW), // PlaceHolder  60
	FNSIG1(DW), // PlaceHolder  61
	FNSIG1(DW), // PlaceHolder  62
	FNSIG1(DW), // PlaceHolder  63
	FNSIG1(DW), // PlaceHolder  64
	FNSIG1(DW), // PlaceHolder  65
	FNSIG1(DW), // PlaceHolder  66
	FNSIG1(DW), // PlaceHolder  67
	FNSIG1(DW), // PlaceHolder  68
	FNSIG1(DW), // PlaceHolder  69
	FNSIG1(DW), // PlaceHolder  70
	FNSIG1(DW), // PlaceHolder  71
	FNSIG1(DW), // PlaceHolder  72
	FNSIG1(DW), // SendChangeNotificationToWindowI
};


// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndCommandBar;	// command bar handle

// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_ACTIVESYNCFIX));
	g_hInstance = hInstance;
	HWND hTaskBar = CreateTaskbar();
	HANDLE hAPISet = CreateAPISet((char *)"SHEL", NUM_APIS, VTable, SigTable);
	HANDLE hShellAPIs = OpenEvent(EVENT_ALL_ACCESS, FALSE, TEXT("SYSTEM/ShellAPIReady"));

	RegisterAPISet(hAPISet, SH_SHELL);

	// This is what makes it work!
	SetEvent(hShellAPIs);
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ACTIVESYNCFIX));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable


    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_ACTIVESYNCFIX, szWindowClass, MAX_LOADSTRING);


    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }


    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    if (g_hWndCommandBar)
    {
        CommandBar_Show(g_hWndCommandBar, TRUE);
    }

    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;                 // device context (DC) for window  
	
	PAINTSTRUCT ps;          // paint data for BeginPaint and EndPaint  
	static HDC hdcCompat;    // DC for copying bitmap  
	static RECT rcBmp;       // rectangle that encloses bitmap  
	static HBITMAP hbmp;     // handle of bitmap to display  
	static HBRUSH hbrBkgnd;  // handle of background-color brush  
	static COLORREF crBkgnd; // color of client-area background  
	static HPEN hpenDot;     // handle of dotted pen  
    int wmId, wmEvent;
	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_FILE_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_CREATE:
		//hdc = GetDC(hWnd); 
		//hdcCompat = CreateCompatibleDC(hdc); 
		SelectObject(hdcCompat, hbmp); 
		//ReleaseDC(hWnd, hdc); 
		break;
	case WM_PAINT:
		BeginPaint(hWnd, &ps); 
		EndPaint(hWnd, &ps); 
		break;
	case WM_DESTROY:
		CommandBar_Destroy(g_hWndCommandBar);
		PostQuitMessage(0);
		break;


	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

